use serde::{Deserialize, Serialize};

#[derive(Debug, Serialize, Deserialize)]
#[serde(tag = "t", content = "d", rename_all = "SCREAMING_SNAKE_CASE")]
pub enum RestEvent {
    /// Sent when a user creates or joins a guild (chat -> identity)
    GuildJoin { guild_id: String, user_id: String },
    /// Sent when a user leaves or is removed from a guild (chat -> identity)
    GuildLeave { guild_id: String, user_id: String },
    /// Sent when a user updates their profile (identity -> chat)
    UserUpdate {
        user_id: String,
        username: Option<String>,
        avatar: Option<String>,
    },
    /// Sent when a user deletes their account (identity -> chat)
    UserDelete { user_id: String },
}
